Index: trunk/source/processes/electromagnetic/standard/src/G4HeatedKleinNishinaCompton.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4HeatedKleinNishinaCompton.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4HeatedKleinNishinaCompton.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4HeatedKleinNishinaCompton.cc,v 1.5 2009/04/12 17:09:57 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4InitXscPAI.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4InitXscPAI.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4InitXscPAI.cc	(revision 1196)
@@ -26,5 +26,5 @@
 //
 // $Id: G4InitXscPAI.cc,v 1.9 2006/06/29 19:53:00 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // 
Index: trunk/source/processes/electromagnetic/standard/src/G4IonFluctuations.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4IonFluctuations.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4IonFluctuations.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4IonFluctuations.cc,v 1.26 2009/03/31 13:24:40 toshito Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4KleinNishinaCompton.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4KleinNishinaCompton.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4KleinNishinaCompton.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4KleinNishinaCompton.cc,v 1.10 2009/05/15 17:12:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4MollerBhabhaModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4MollerBhabhaModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4MollerBhabhaModel.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4MollerBhabhaModel.cc,v 1.34 2009/04/24 17:15:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4MollerBhabhaModel.cc,v 1.35 2009/11/09 19:16:13 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -258,15 +258,16 @@
 
   //density correction 
-  G4double cden  = material->GetIonisation()->GetCdensity();
-  G4double mden  = material->GetIonisation()->GetMdensity();
-  G4double aden  = material->GetIonisation()->GetAdensity();
-  G4double x0den = material->GetIonisation()->GetX0density();
-  G4double x1den = material->GetIonisation()->GetX1density();
+  //G4double cden  = material->GetIonisation()->GetCdensity();
+  //G4double mden  = material->GetIonisation()->GetMdensity();
+  //G4double aden  = material->GetIonisation()->GetAdensity();
+  //G4double x0den = material->GetIonisation()->GetX0density();
+  //G4double x1den = material->GetIonisation()->GetX1density();
   G4double x     = log(bg2)/twoln10;
 
-  if (x >= x0den) {
-    dedx -= twoln10*x - cden;
-    if (x < x1den) dedx -= aden*pow(x1den-x, mden);
-  } 
+  //if (x >= x0den) {
+  //  dedx -= twoln10*x - cden;
+  //  if (x < x1den) dedx -= aden*pow(x1den-x, mden);
+  //}
+  dedx -= material->GetIonisation()->DensityCorrection(x); 
 
   // now you can compute the total ionization loss
Index: trunk/source/processes/electromagnetic/standard/src/G4MscModel71.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4MscModel71.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4MscModel71.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4MscModel71.cc,v 1.7 2009/04/09 18:41:18 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4MscModel71.cc,v 1.8 2009/11/01 13:05:01 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -104,5 +104,5 @@
 G4MscModel71::G4MscModel71(G4double& m_dtrl, G4double& m_NuclCorrPar,
 			   G4double& m_FactPar, G4double& m_factail,
-		       G4bool& m_samplez, const G4String& nam)
+			   G4bool& m_samplez, const G4String& nam)
   : G4VEmModel(nam),
   taubig(8.0),
@@ -117,5 +117,9 @@
 {
   stepmin       = 1.e-6*mm;
-  currentRange  = 0. ;
+  currentRange  = 0.;
+  G4cout << G4endl;
+  G4cout << "!!! G4MscModel71 class is obsolete and will be removed for the next major Geant4 release !!!" << G4endl;
+  G4cout << "!!! Please use other models (G4UrbanMscModel90, 92, 93) !!!" << G4endl;
+  G4cout << G4endl;
 }
 
Index: trunk/source/processes/electromagnetic/standard/src/G4MultipleScattering.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4MultipleScattering.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4MultipleScattering.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4MultipleScattering.cc,v 1.75 2008/10/15 17:53:44 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4MultipleScattering.cc,v 1.77 2009/11/01 13:05:01 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -----------------------------------------------------------------------------
@@ -129,5 +129,5 @@
 
 #include "G4MultipleScattering.hh"
-#include "G4UrbanMscModel.hh"
+#include "G4UrbanMscModel92.hh"
 #include "G4MscStepLimitType.hh"
 #include "G4UrbanMscModel.hh"
@@ -141,4 +141,10 @@
 {
   isInitialized = false;  
+  G4cout << G4endl;
+  G4cout << "!!! G4MultipleScattering class is obsolete and will be removed for the next major Geant4 release !!!" << G4endl;
+  G4cout << "!!! Please use G4eMultipleScattering for e+ and e- !!!" << G4endl;
+  G4cout << "!!! Please use G4MuMultipleScattering for mu+ and mu- !!!" << G4endl;
+  G4cout << "!!! Please use G4hMultipleScattering for hadrons and ions !!!" << G4endl;
+  G4cout << G4endl;
 }
 
@@ -157,34 +163,11 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-void G4MultipleScattering::InitialiseProcess(const G4ParticleDefinition* p)
+void G4MultipleScattering::InitialiseProcess(const G4ParticleDefinition*)
 {
-  // Modification of parameters between runs
-  if(isInitialized) {
-    if (p->GetParticleType() != "nucleus") {
-      mscUrban->SetStepLimitType(StepLimitType());
-      mscUrban->SetLateralDisplasmentFlag(LateralDisplasmentFlag());
-      mscUrban->SetSkin(Skin());
-      mscUrban->SetRangeFactor(RangeFactor());
-      mscUrban->SetGeomFactor(GeomFactor());
-    }
-    return;
-  }
-
-  // defaults for ions, which cannot be overwritten
-  if (p->GetParticleType() == "nucleus") {
-    SetStepLimitType(fMinimal);
-    SetLateralDisplasmentFlag(false);
-    SetBuildLambdaTable(false);
-  }
+  if(isInitialized) return;
 
   // initialisation of parameters - defaults for particles other
   // than ions can be overwritten by users
-  mscUrban = new G4UrbanMscModel();
-  mscUrban->SetStepLimitType(StepLimitType());
-  mscUrban->SetLateralDisplasmentFlag(LateralDisplasmentFlag());
-  mscUrban->SetSkin(Skin());
-  mscUrban->SetRangeFactor(RangeFactor());
-  mscUrban->SetGeomFactor(GeomFactor());
-
+  mscUrban = new G4UrbanMscModel92();
   AddEmModel(1,mscUrban);
   isInitialized = true;
Index: trunk/source/processes/electromagnetic/standard/src/G4MultipleScattering71.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4MultipleScattering71.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4MultipleScattering71.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MultipleScattering71.cc,v 1.5 2008/07/16 11:27:41 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -----------------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4PAIModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PAIModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4PAIModel.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PAIModel.cc,v 1.47 2009/04/09 18:41:18 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4PAIModel.cc,v 1.51 2009/08/12 21:28:50 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -41,4 +41,5 @@
 // 16.08.04 V.Grichine, bug fixed in massRatio for DEDX, CrossSection, SampleSecondary
 // 08.04.05 Major optimisation of internal interfaces (V.Ivantchenko)
+// 26.07.09 Fixed logic to work with several materials (V.Ivantchenko)
 //
 
@@ -63,5 +64,4 @@
 #include "G4ParticleDefinition.hh"
 #include "G4ParticleChangeForLoss.hh"
-#include "G4GeometryTolerance.hh"
 
 ////////////////////////////////////////////////////////////////////////
@@ -162,8 +162,4 @@
 
   // Prepare initialization
-
-  fPAItransferTable = new G4PhysicsTable(fTotBin);
-  fPAIdEdxTable = new G4PhysicsTable(fTotBin);
-
   const G4ProductionCutsTable* theCoupleTable =
         G4ProductionCutsTable::GetProductionCutsTable();
@@ -182,7 +178,10 @@
       //G4cout << "Reg <" <<curReg->GetName() << ">  mat <" 
       //	     << fMaterial->GetName() << ">  fCouple= " 
-      //	     << fCutCouple<<G4endl;
+      //	     << fCutCouple<<"  " << p->GetParticleName() <<G4endl;
       if( fCutCouple ) {
 	fMaterialCutsCoupleVector.push_back(fCutCouple);
+
+	fPAItransferTable = new G4PhysicsTable(fTotBin+1);
+	fPAIdEdxTable = new G4PhysicsTable(fTotBin+1);
 
 	fDeltaCutInKinEnergy = 
@@ -263,5 +262,4 @@
   G4double tau, Tmax, Tmin, Tkin, deltaLow, gamma, bg2 ;
 
-  if(fdEdxVector) delete fdEdxVector;
   fdEdxVector = new G4PhysicsLogVector( fLowestKineticEnergy,
 					fHighestKineticEnergy,
@@ -272,5 +270,5 @@
   deltaLow = 100.*eV; // 0.5*eV ;
 
-  for (G4int i = 0 ; i < fTotBin ; i++)  //The loop for the kinetic energy
+  for (G4int i = 0 ; i <= fTotBin ; i++)  //The loop for the kinetic energy
   {
     LowEdgeEnergy = fParticleEnergyVector->GetLowEdgeEnergy(i) ;
@@ -283,17 +281,7 @@
     Tkin = Tmax ;
 
-    // G4cout<<"proton Tkin = "<<LowEdgeEnergy/MeV<<" MeV"
-    // <<" Tmax = "<<Tmax/MeV<<" MeV"<<G4endl;
-  
     if ( Tmax < Tmin + deltaLow )  // low energy safety
       Tkin = Tmin + deltaLow ;
 
-    /*
-    G4PAIxSection protonPAI( fMatIndex,
-                             Tkin,
-                             bg2,
-                             fSandiaPhotoAbsCof,
-                             fSandiaIntervalNumber  ) ;
-    */
     fPAIySection.Initialize(fMaterial, Tkin, bg2);
 
@@ -325,8 +313,4 @@
 
   }                                        // end of Tkin loop
-  //  theLossTable->insert(fdEdxVector);
-  // end of material loop
-  // G4cout<<"G4PAIonisation::BuildPAIonisationTable() have been called"<<G4endl ;
-  // G4cout<<"G4PAIonisation::BuildLossTable() have been called"<<G4endl ;
 }
 
@@ -339,10 +323,4 @@
 void G4PAIModel::BuildLambdaVector()
 {
-  //G4double kCarTolerance = G4GeometryTolerance::GetInstance()
-  //                         ->GetSurfaceTolerance();
-
-  if (fLambdaVector)   delete fLambdaVector;
-  if (fdNdxCutVector)  delete fdNdxCutVector;
-
   fLambdaVector = new G4PhysicsLogVector( fLowestKineticEnergy,
 					  fHighestKineticEnergy,
@@ -356,10 +334,12 @@
 	  <<fDeltaCutInKinEnergy/keV<<" keV"<<G4endl;
   }
-  for (G4int i = 0 ; i < fTotBin ; i++ )
+  for (G4int i = 0 ; i <= fTotBin ; i++ )
   {
     G4double dNdxCut = GetdNdxCut(i,fDeltaCutInKinEnergy) ;
-    G4double lambda = dNdxCut <= DBL_MIN ? DBL_MAX: 1.0/dNdxCut ;
-
-    //    if (lambda <= 1000*kCarTolerance) lambda = 1000*kCarTolerance ; // Mmm ???
+    //G4cout << "i= " << i << " x= " << dNdxCut << G4endl;
+    if(dNdxCut < 0.0) dNdxCut = 0.0; 
+    //    G4double lambda = dNdxCut <= DBL_MIN ? DBL_MAX: 1.0/dNdxCut ;
+    G4double lambda = DBL_MAX;
+    if(dNdxCut > 0.0) lambda = 1.0/dNdxCut;
 
     fLambdaVector->PutValue(i, lambda) ;
@@ -395,4 +375,6 @@
   y1 = (*(*fPAItransferTable)(iPlace))(iTransfer-1) ;
   y2 = (*(*fPAItransferTable)(iPlace))(iTransfer) ;
+  if(y1 < 0.0) y1 = 0.0;
+  if(y2 < 0.0) y2 = 0.0;
   // G4cout<<"y1 = "<<y1<<"; "<<"y2 = "<<y2<<G4endl;
   x1 = (*fPAItransferTable)(iPlace)->GetLowEdgeEnergy(iTransfer-1) ;
@@ -409,4 +391,5 @@
   }
   //  G4cout<<""<<dNdxCut<<G4endl;
+  if(dNdxCut < 0.0) dNdxCut = 0.0; 
   return dNdxCut ;
 }
@@ -420,5 +403,5 @@
   G4int iTransfer;
   G4double x1, x2, y1, y2, dEdxCut;
-  // G4cout<<"iPlace = "<<iPlace<<"; "<<"transferCut = "<<transferCut<<G4endl;
+  //G4cout<<"iPlace = "<<iPlace<<"; "<<"transferCut = "<<transferCut<<G4endl;
   // G4cout<<"size = "<<G4int((*fPAIdEdxTable)(iPlace)->GetVectorLength())
   //           <<G4endl;  
@@ -438,8 +421,10 @@
   y1 = (*(*fPAIdEdxTable)(iPlace))(iTransfer-1) ;
   y2 = (*(*fPAIdEdxTable)(iPlace))(iTransfer) ;
-  // G4cout<<"y1 = "<<y1<<"; "<<"y2 = "<<y2<<G4endl;
+  if(y1 < 0.0) y1 = 0.0;
+  if(y2 < 0.0) y2 = 0.0;
+  //G4cout<<"y1 = "<<y1<<"; "<<"y2 = "<<y2<<G4endl;
   x1 = (*fPAIdEdxTable)(iPlace)->GetLowEdgeEnergy(iTransfer-1) ;
   x2 = (*fPAIdEdxTable)(iPlace)->GetLowEdgeEnergy(iTransfer) ;
-  // G4cout<<"x1 = "<<x1<<"; "<<"x2 = "<<x2<<G4endl;
+  //G4cout<<"x1 = "<<x1<<"; "<<"x2 = "<<x2<<G4endl;
 
   if ( y1 == y2 )    dEdxCut = y2 ;
@@ -451,5 +436,6 @@
     else             dEdxCut = y1 + (transferCut - x1)*(y2 - y1)/(x2 - x1) ;      
   }
-  //  G4cout<<""<<dEdxCut<<G4endl;
+  //G4cout<<""<<dEdxCut<<G4endl;
+  if(dEdxCut < 0.0) dEdxCut = 0.0; 
   return dEdxCut ;
 }
@@ -463,5 +449,4 @@
 {
   G4int iTkin,iPlace;
-  size_t jMat;
   
   //G4double cut = std::min(MaxSecondaryEnergy(p, kineticEnergy), cutEnergy);
@@ -474,18 +459,27 @@
   const G4MaterialCutsCouple* matCC = CurrentCouple();
 
-  for( jMat = 0 ;jMat < fMaterialCutsCoupleVector.size() ; ++jMat )
+  size_t jMat = 0;
+  for(;jMat < fMaterialCutsCoupleVector.size(); ++jMat )
   {
     if( matCC == fMaterialCutsCoupleVector[jMat] ) break;
   }
-  if(jMat == fMaterialCutsCoupleVector.size() && jMat > 0) jMat--;
+  //G4cout << "jMat= " << jMat 
+  //	 << " jMax= " << fMaterialCutsCoupleVector.size()
+  //       << " matCC: " << matCC;
+  //if(matCC) G4cout << " mat: " << matCC->GetMaterial()->GetName();
+  //  G4cout << G4endl;
+  if(jMat == fMaterialCutsCoupleVector.size()) return 0.0;
 
   fPAIdEdxTable = fPAIdEdxBank[jMat];
   fdEdxVector = fdEdxTable[jMat];
-  for(iTkin = 0 ; iTkin < fTotBin ; iTkin++)
+  for(iTkin = 0 ; iTkin <= fTotBin ; iTkin++)
   {
     if(scaledTkin < fParticleEnergyVector->GetLowEdgeEnergy(iTkin)) break ;    
   }
+  //G4cout << "E= " << scaledTkin << " iTkin= " << iTkin 
+  //	 << "  " << fdEdxVector->GetVectorLength()<<G4endl; 
   iPlace = iTkin - 1;
   if(iPlace < 0) iPlace = 0;
+  else if(iPlace >= fTotBin) iPlace = fTotBin-1;
   G4double dEdx = charge2*( (*fdEdxVector)(iPlace) - GetdEdxCut(iPlace,cut) );
   if( dEdx < 0.) dEdx = 0.;
@@ -502,5 +496,4 @@
 {
   G4int iTkin,iPlace;
-  size_t jMat;
   G4double tmax = std::min(MaxSecondaryEnergy(p, kineticEnergy), maxEnergy);
   if(tmax <= cutEnergy) return 0.0;
@@ -511,13 +504,14 @@
   const G4MaterialCutsCouple* matCC = CurrentCouple();
 
-  for( jMat = 0 ;jMat < fMaterialCutsCoupleVector.size() ; ++jMat )
+  size_t jMat = 0;
+  for(;jMat < fMaterialCutsCoupleVector.size(); ++jMat )
   {
     if( matCC == fMaterialCutsCoupleVector[jMat] ) break;
   }
-  if(jMat == fMaterialCutsCoupleVector.size() && jMat > 0) jMat--;
+  if(jMat == fMaterialCutsCoupleVector.size()) return 0.0;
 
   fPAItransferTable = fPAIxscBank[jMat];
 
-  for(iTkin = 0 ; iTkin < fTotBin ; iTkin++)
+  for(iTkin = 0 ; iTkin <= fTotBin ; iTkin++)
   {
     if(scaledTkin < fParticleEnergyVector->GetLowEdgeEnergy(iTkin)) break ;    
@@ -525,14 +519,15 @@
   iPlace = iTkin - 1;
   if(iPlace < 0) iPlace = 0;
-
-  // G4cout<<"iPlace = "<<iPlace<<"; tmax = "
+  else if(iPlace >= fTotBin) iPlace = fTotBin-1; 
+
+  //G4cout<<"iPlace = "<<iPlace<<"; tmax = "
   // <<tmax<<"; cutEnergy = "<<cutEnergy<<G4endl;  
   cross1 = GetdNdxCut(iPlace,tmax) ;
-  // G4cout<<"cross1 = "<<cross1<<G4endl;  
+  //G4cout<<"cross1 = "<<cross1<<G4endl;  
   cross2 = GetdNdxCut(iPlace,cutEnergy) ;  
-  // G4cout<<"cross2 = "<<cross2<<G4endl;  
+  //G4cout<<"cross2 = "<<cross2<<G4endl;  
   cross  = (cross2-cross1)*charge2;
-  // G4cout<<"cross = "<<cross<<G4endl;  
-  if( cross < DBL_MIN) cross = DBL_MIN;
+  //G4cout<<"cross = "<<cross<<G4endl;  
+  if( cross < DBL_MIN) cross = 0.0;
   //  if( cross2 < DBL_MIN) cross2 = DBL_MIN;
 
@@ -552,10 +547,10 @@
 				   G4double maxEnergy)
 {
-  size_t jMat;
-  for( jMat = 0 ;jMat < fMaterialCutsCoupleVector.size() ; ++jMat )
+  size_t jMat = 0;
+  for(;jMat < fMaterialCutsCoupleVector.size(); ++jMat )
   {
     if( matCC == fMaterialCutsCoupleVector[jMat] ) break;
   }
-  if(jMat == fMaterialCutsCoupleVector.size() && jMat > 0) jMat--;
+  if(jMat == fMaterialCutsCoupleVector.size()) return;
 
   fPAItransferTable = fPAIxscBank[jMat];
@@ -636,5 +631,5 @@
   G4double transfer = 0.0, position, dNdxCut1, dNdxCut2, E1, E2, W1, W2, W ;
 
-  for(iTkin=0;iTkin<fTotBin;iTkin++)
+  for(iTkin=0;iTkin<=fTotBin;iTkin++)
   {
     if(scaledTkin < fParticleEnergyVector->GetLowEdgeEnergy(iTkin))  break ;
@@ -643,4 +638,5 @@
   // G4cout<<"from search, iPlace = "<<iPlace<<G4endl ;
   if(iPlace < 0) iPlace = 0;
+  else if(iPlace >= fTotBin) iPlace = fTotBin-1; 
   dNdxCut1 = (*fdNdxCutVector)(iPlace) ;  
   // G4cout<<"dNdxCut1 = "<<dNdxCut1<<G4endl ;
@@ -758,20 +754,19 @@
                                                G4double&)
 {
-  size_t jMat;
-  for( jMat = 0 ;jMat < fMaterialCutsCoupleVector.size() ; ++jMat )
+  size_t jMat = 0;
+  for(;jMat < fMaterialCutsCoupleVector.size(); ++jMat )
   {
     if( material == fMaterialCutsCoupleVector[jMat]->GetMaterial() ) break;
   }
-  if(jMat == fMaterialCutsCoupleVector.size() && jMat > 0) jMat--;
+  if(jMat == fMaterialCutsCoupleVector.size()) return 0.0;
 
   fPAItransferTable = fPAIxscBank[jMat];
   fdNdxCutVector   = fdNdxCutTable[jMat];
 
-  G4int iTkin, iTransfer, iPlace  ;
+  G4int iTkin, iTransfer, iPlace;
   G4long numOfCollisions=0;
 
-  //  G4cout<<"G4PAIModel::SampleFluctuations"<<G4endl ;
-  //G4cout<<"in:  "<<fMaterialCutsCoupleVector[jMat]->GetMaterial()->GetName()<<G4endl ;
-
+  //G4cout<<"G4PAIModel::SampleFluctuations"<<G4endl ;
+  //G4cout<<"in: "<<fMaterialCutsCoupleVector[jMat]->GetMaterial()->GetName()<<G4endl;
   G4double loss = 0.0, charge2 ;
   G4double stepSum = 0., stepDelta, lambda, omega; 
@@ -784,5 +779,5 @@
   G4double TkinScaled = Tkin*MassRatio ;
 
-  for(iTkin=0;iTkin<fTotBin;iTkin++)
+  for(iTkin=0;iTkin<=fTotBin;iTkin++)
   {
     if(TkinScaled < fParticleEnergyVector->GetLowEdgeEnergy(iTkin))   break ;
@@ -790,8 +785,8 @@
   iPlace = iTkin - 1 ; 
   if(iPlace < 0) iPlace = 0;
-  //  G4cout<<"from search, iPlace = "<<iPlace<<G4endl ;
+  else if(iPlace >= fTotBin) iPlace = fTotBin - 1;
+  //G4cout<<"from search, iPlace = "<<iPlace<<G4endl ;
   dNdxCut1 = (*fdNdxCutVector)(iPlace) ;  
-  //  G4cout<<"dNdxCut1 = "<<dNdxCut1<<G4endl ;
-
+  //G4cout<<"dNdxCut1 = "<<dNdxCut1<<G4endl ;
 
   if(iTkin == fTotBin) // Fermi plato, try from left
@@ -810,5 +805,5 @@
      numOfCollisions++;
     }   
-    //    G4cout<<"##1 numOfCollisions = "<<numOfCollisions<<G4endl ;
+    //G4cout<<"##1 numOfCollisions = "<<numOfCollisions<<G4endl ;
 
     while(numOfCollisions)
@@ -823,5 +818,5 @@
       }
       omega = GetEnergyTransfer(iPlace,position,iTransfer);
-      // G4cout<<"G4PAIModel::SampleFluctuations, omega = "<<omega/keV<<" keV; "<<"\t";
+      //G4cout<<"G4PAIModel::SampleFluctuations, omega = "<<omega/keV<<" keV; "<<"\t";
       loss += omega;
       numOfCollisions-- ;
@@ -831,5 +826,5 @@
   {
     dNdxCut2 = (*fdNdxCutVector)(iPlace+1) ; 
-    //  G4cout<<"dNdxCut2 = "<<dNdxCut2<<G4endl ;
+    //G4cout<<"dNdxCut2 = "<<dNdxCut2<< " iTkin= "<<iTkin<<" iPlace= "<<iPlace<<G4endl;
  
     if(iTkin == 0) // Tkin is too small, trying from right only
@@ -839,15 +834,15 @@
       //  numOfCollisions = CLHEP::RandPoisson::shoot(meanNumber) ;
       //  numOfCollisions = G4Poisson(meanNumber) ;
-    if( meanNumber > 0.) lambda = step/meanNumber;
-    else                 lambda = DBL_MAX;
-    while(numb)
-    {
-     stepDelta = CLHEP::RandExponential::shoot(lambda);
-     stepSum += stepDelta;
-     if(stepSum >= step) break;
-     numOfCollisions++;
-    }   
-
-    //G4cout<<"##2 numOfCollisions = "<<numOfCollisions<<G4endl ;
+      if( meanNumber > 0.) lambda = step/meanNumber;
+      else                 lambda = DBL_MAX;
+      while(numb)
+	{
+	  stepDelta = CLHEP::RandExponential::shoot(lambda);
+	  stepSum += stepDelta;
+	  if(stepSum >= step) break;
+	  numOfCollisions++;
+	}   
+
+      //G4cout<<"##2 numOfCollisions = "<<numOfCollisions<<G4endl ;
 
       while(numOfCollisions)
@@ -862,5 +857,5 @@
         }
         omega = GetEnergyTransfer(iPlace,position,iTransfer);
-        // G4cout<<omega/keV<<"\t";
+        //G4cout<<omega/keV<<"\t";
         loss += omega;
         numOfCollisions-- ;
@@ -875,7 +870,8 @@
       W2 = (TkinScaled - E1)*W ;
 
-      // G4cout<<"(*(*fPAItransferTable)(iPlace))(0) = "<<
+      //G4cout << fPAItransferTable->size() << G4endl;
+      //G4cout<<"(*(*fPAItransferTable)(iPlace))(0) = "<<
       //   (*(*fPAItransferTable)(iPlace))(0)<<G4endl ;
-      // G4cout<<"(*(*fPAItransferTable)(iPlace+1))(0) = "<<
+      //G4cout<<"(*(*fPAItransferTable)(iPlace+1))(0) = "<<
       //     (*(*fPAItransferTable)(iPlace+1))(0)<<G4endl ;
 
@@ -885,15 +881,15 @@
       //  numOfCollisions = RandPoisson::shoot(meanNumber) ;
       // numOfCollisions = G4Poisson(meanNumber) ;
-    if( meanNumber > 0.) lambda = step/meanNumber;
-    else                 lambda = DBL_MAX;
-    while(numb)
-    {
-     stepDelta = CLHEP::RandExponential::shoot(lambda);
-     stepSum += stepDelta;
-     if(stepSum >= step) break;
-     numOfCollisions++;
-    }   
-
-    //G4cout<<"##3 numOfCollisions = "<<numOfCollisions<<endl ;
+      if( meanNumber > 0.) lambda = step/meanNumber;
+      else                 lambda = DBL_MAX;
+      while(numb)
+	{
+	  stepDelta = CLHEP::RandExponential::shoot(lambda);
+	  stepSum += stepDelta;
+	  if(stepSum >= step) break;
+	  numOfCollisions++;
+	}   
+
+      //G4cout<<"##3 numOfCollisions = "<<numOfCollisions<<endl ;
 
       while(numOfCollisions)
@@ -923,5 +919,5 @@
     }
   } 
-  //  G4cout<<"PAIModel AlongStepLoss = "<<loss/keV<<" keV, on step = "
+  //G4cout<<"PAIModel AlongStepLoss = "<<loss/keV<<" keV, on step = "
   //  <<step/mm<<" mm"<<G4endl ; 
   if(loss > Tkin) loss=Tkin;
Index: trunk/source/processes/electromagnetic/standard/src/G4PAIPhotonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PAIPhotonModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4PAIPhotonModel.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PAIPhotonModel.cc,v 1.22 2009/04/09 18:41:18 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4PAIPhotonModel.cc,v 1.23 2009/07/26 15:51:01 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -310,5 +310,5 @@
   deltaLow = 100.*eV; // 0.5*eV ;
 
-  for (G4int i = 0 ; i < fTotBin ; i++)  //The loop for the kinetic energy
+  for (G4int i = 0 ; i <= fTotBin ; i++)  //The loop for the kinetic energy
   {
     LowEdgeEnergy = fProtonEnergyVector->GetLowEdgeEnergy(i) ;
@@ -441,5 +441,5 @@
 	  <<photonCutInKineticEnergyNow/keV<<" keV"<<G4endl;
   }
-  for ( i = 0 ; i < fTotBin ; i++ )
+  for ( i = 0 ; i <= fTotBin ; i++ )
   {
     dNdxPhotonCut  = GetdNdxPhotonCut(i,photonCutInKineticEnergyNow);
@@ -664,5 +664,5 @@
   fPAIdEdxTable = fPAIdEdxBank[jMat];
   fdEdxVector = fdEdxTable[jMat];
-  for(iTkin = 0 ; iTkin < fTotBin ; iTkin++)
+  for(iTkin = 0 ; iTkin <= fTotBin ; iTkin++)
   {
     if(scaledTkin < fProtonEnergyVector->GetLowEdgeEnergy(iTkin)) break ;    
@@ -722,5 +722,5 @@
   fPAIplasmonTable  = fPAIplasmonBank[jMat];
 
-  for(iTkin = 0 ; iTkin < fTotBin ; iTkin++)
+  for(iTkin = 0 ; iTkin <= fTotBin ; iTkin++)
   {
     if(scaledTkin < fProtonEnergyVector->GetLowEdgeEnergy(iTkin)) break ;    
@@ -789,5 +789,5 @@
 
   G4int iTkin;
-  for(iTkin=0;iTkin<fTotBin;iTkin++)
+  for(iTkin=0;iTkin<=fTotBin;iTkin++)
   {
     if(scaledTkin < fProtonEnergyVector->GetLowEdgeEnergy(iTkin))  break ;
@@ -1052,5 +1052,5 @@
   G4double cof        = step*charge2;
 
-  for( iTkin = 0; iTkin < fTotBin; iTkin++)
+  for( iTkin = 0; iTkin <= fTotBin; iTkin++)
   {
     if(scaledTkin < fProtonEnergyVector->GetLowEdgeEnergy(iTkin))   break ;
Index: trunk/source/processes/electromagnetic/standard/src/G4PAIxSection.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PAIxSection.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4PAIxSection.cc	(revision 1196)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PAIxSection.cc,v 1.24 2008/05/30 16:04:40 grichine Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // 
